# `puppet` Puppet Module

#### Table of Contents

1. [Overview](#overview)
2. [Setup](#setup)
3. [Usage](#usage)
4. [Limitations](#limitations)
5. [Development](#development)

## Overview

This module updates Puppet.

The instruction comes from:
https://docs.puppetlabs.com/guides/install_puppet/install_debian_ubuntu.html

## Setup

To install the module run:

    sudo puppet install module gajdaw-puppet

## Usage

You can update Puppet running:

    sudo puppet apply -e "include puppet"

You can also use the example:

    sudo puppet apply example-01.pp

## Limitations

The module was tested on:

* Ubuntu
  - 12.04 (precise) (Vagrant box: ubuntu/precise32)
  - 14.04 (trusty) (Vagrant box: ubuntu/trusty32)
* Debian
  - 6.0 (squeeze) (Vagrant box: chef/debian-6.0.8)
  - 7.4 (wheezy) (Vagrant box: chef/debian-7.4)
* CentOS
  - 6 (Vagrant box: puppetlabs/centos-6.5-64-puppet)
  - 7 (Vagrant box: puppetlabs/centos-7.0-64-puppet)
* Fedora
  - 20 (Vagrant box: chef/fedora-20)

If you use this module for Puppet 2.7 or Puppet 3.4
you will get the following error message:

    Error: Report processor failed: undefined method `exist?'
    for Puppet::FileSystem:Module

Regardless this, Puppet will be succesfully upgraded.
This happens in `ubuntu/precise32` and `ubuntu/trusty32` Vagrant Boxes.

## What if puppet is not installed at all?

The instructions to install puppet are available at
https://docs.puppetlabs.com/pe/latest/install_agents.html

The commands to run on Ubuntu 12.04 (precise):

    $ sudo wget https://apt.puppetlabs.com/puppetlabs-release-precise.deb
    $ sudo dpkg -i puppetlabs-release-precise.deb
    $ sudo apt-get update -y
    $ sudo apt-get install puppet -y

The commands to run on Ubuntu 14.04 (trusty):

    $ sudo wget https://apt.puppetlabs.com/puppetlabs-release-trusty.deb
    $ sudo dpkg -i puppetlabs-release-trusty.deb
    $ sudo apt-get update -y
    $ sudo apt-get install puppet -y

The commands to run on Debian 7.4 (wheezy):

    $ sudo wget https://apt.puppetlabs.com/puppetlabs-release-wheezy.deb
    $ sudo dpkg -i puppetlabs-release-wheezy.deb
    $ sudo apt-get update -y
    $ sudo apt-get install puppet -y

The commands to run on Debian 6.0 (squeeze):

    $ sudo wget https://apt.puppetlabs.com/puppetlabs-release-squeeze.deb
    $ sudo dpkg -i puppetlabs-release-squeeze.deb
    $ sudo apt-get update -y
    $ sudo apt-get install puppet -y

The commands to run on CentOS 7.0:

    $ sudo rpm -ivh http://yum.puppetlabs.com/puppetlabs-release-el-7.noarch.rpm
    $ sudo yum update -y
    $ sudo yum install puppet -y

The commands to run on CentOS 6.5:

    $ sudo rpm -ivh http://yum.puppetlabs.com/puppetlabs-release-el-6.noarch.rpm
    $ sudo yum update -y
    $ sudo yum install puppet -y

The commands to run on Fedora 20:

    $ sudo rpm -ivh http://yum.puppetlabs.com/puppetlabs-release-fedora-20.noarch.rpm
    $ sudo yum update -y
    $ sudo yum install puppet -y

## Development

For development instructions visit
[Puppet Modules Factory](https://github.com/puppet-by-examples/puppet-modules-factory)
